-- recipe functions; version 001 from 2017-09-20
-- /darkfrei

function ilog (content)
	if not (content) then
		log ("no content, sorry")
		return
	end
	if type (content) == "table" then log (serpent.block(content, {comment = false})) return end
	log (content)
end

function table_size (tabl)
	local k = 0
	for i, v in pairs (tabl) do
		k = k + 1
	end
	return k
end

function table_last (tabl)
	local last = 0
	for i, v in pairs (tabl) do
		last = i
	end
	return last
end


recipe_functions = {}
--results = {{type = "item", name = "stone-brick", amount = 1}}


function recipe_functions.norm_ingredients(recipe)
	if recipe.ingredients then
		for i, ingredient in pairs (recipe.ingredients) do
			if not ingredient.type then
				ingredient.type = "item"
				ingredient.name = ingredient.name or ingredient[1]
				ingredient[1] = nil
				ingredient.amount = ingredient.amount or ingredient[2]
				ingredient[2] = nil
				--log ('Was no type by ' .. ingredient.name)
			else
				--log ('item:' ..ingredient.name .. ' type:' .. ingredient.type)
			end
		end
	else
		log ('Warning! No ingredients!')
		ilog (recipe)
	end
end

function recipe_functions.norm_results (recipe)
	if recipe.result then
		local amount = recipe.result_count or 1
		recipe.results = {{type = "item", name = recipe.result, amount = amount}}
		recipe.result = nil
		recipe.result_count = nil
	end

	-- local results = recipe.results or {}
	-- if not (results) then
		-- if (not results) and (not results.name) then
		--log ("correct: " .. results.name)
		-- else
			-- ilog (results)
		-- end
		-- local recipe_result_name = recipe.result
		-- local recipe_result_amount = recipe.result_count or 1
		-- results = {type = "item", name = recipe_result_name, amount = recipe_result_amount}
	-- end
end

function recipe_functions.norm_results_icons (recipe)
	if recipe.icon then 
		--log ('icons from icon: ' .. recipe.name)
		recipe.icons = {{icon = recipe.icon}}
		recipe.icon = nil
	end
	local results = recipe.results or {}
	if table_size(results) == 1 then
		local result_name = results[table_last (results)].name
		local result_item = data.raw.item[result_name]
		if result_item then
			local result_icon = recipe.icon
			if (not (result_icon)) and (result_item.icon) then
				result_icon = result_item.icon
				--log (result_name .. ' added icon from item')
			end
			local result_icons = recipe.icons
			if not (result_icons) and (result_item.icons)  then
				result_icons = result_item.icons
				--log (result_name .. ' added icons from item')
			end
			if not (result_icons) then
				result_icons = {{icon = result_icon}}
				--log (result_name .. ' icon was rewritten ' .. result_icon)
				result_icon = nil
			end
		else
			--log("no item! " .. result_name .. " - " .. serpent.block(recipe, {comment = false}))
		end
	end
end

function recipe_functions.global_iterator ()
	local raw_recipes = data.raw.recipe
	local i = 0
	local recipes_handler = {} -- {{name = "recipe_name", difficultly = "default" / "normal" / "expensive", recipe = {recipe_table}}}
	for recipe_name, recipe in pairs (raw_recipes) do
		if recipe.normal then
			i = i + 2
			recipes_handler[#recipes_handler+1] = {name =recipe.name, difficultly = 'normal', recipe = recipe.normal}
			recipes_handler[#recipes_handler+1] = {name =recipe.name, difficultly = 'expensive', recipe = recipe.expensive}
		else
			i = i + 1
			recipes_handler[#recipes_handler+1] = {name =recipe.name, difficultly = 'default', recipe = recipe}
		end
	end
	return recipes_handler
end

function recipe_functions.list_of_recipe_names ()
	local recipe_names = {}
	local raw_recipes = data.raw.recipe
	for i_name, recipe in pairs (raw_recipes) do
		if not (i_name == recipe.name) then
			log ('Warning! Some problem!')
		end
		recipe_names[#recipe_names+1] = recipe.name
	end
	return recipe_names
end

function recipe_functions.multiplicate_all (factor_k)
	local recipes_handler = recipe_functions.global_iterator ()
	for i, handler in pairs (recipes_handler) do
		local recipe = handler.recipe
		recipe.energy_required = recipe.energy_required or 0.5 -- default for 0.15.34
		recipe.energy_required = recipe.energy_required * factor_k
		for i, ingredient in pairs (recipe.ingredients) do
			ingredient.amount = ingredient.amount * factor_k
		end
		for i, result in pairs (recipe.results) do
			result.amount = result.amount * factor_k
		end
	end
end

return recipe_functions
